-- Register: allowDirectPlanting
-- Adds direct planting for all vehicles
-- Initial 2013-12-08 (c) Scathalh
-- RC 1 2014-01-05 (c) Scathalh
-- RC 1 2014-10-31 (c) Scathalh Migrated to FS15

-- Register the specialization
SpecializationUtil.registerSpecialization("allowDirectPlanting", "allowDirectPlanting", g_currentModDirectory.."allowDirectPlanting.lua")

-- Make object
allowDirectPlanting_Register = {};

function allowDirectPlanting_Register:loadMap(name)
	if self.firstRun == nil then
		self.firstRun = false;
		print("[INFO::allowDirectPlanting] Register allow direct planting...");
		
		-- for each all vehicles
		for k, vehicle in pairs(VehicleTypeUtil.vehicleTypes) do
			if vehicle ~= nil then
				local allowInsertion = true;
				
				-- get all specializations
				for i = 1, table.maxn(vehicle.specializations) do
					local vehicleSpecialization = vehicle.specializations[i];
					
					-- is the vehicle a sowing machine?
					if vehicleSpecialization ~= nil and vehicleSpecialization == SpecializationUtil.getSpecialization("sowingMachine") then
						local locPoint = string.find(vehicle.name, ".", nil, true);
						if locPoint ~= nil then
							local partial = string.sub(vehicle.name,1, locPoint - 1);
							if rawget(SpecializationUtil.specializations, string.format("%s.allowDirectPlanting", partial)) ~= nil then
								allowInsertion = false;								
							end;							
						end;
						
						-- insert the specialization
						if allowInsertion then	
							table.insert(vehicle.specializations, SpecializationUtil.getSpecialization("allowDirectPlanting"));
						end;
					end;
				end;
			end;	
		end;
	end;
end;

function allowDirectPlanting_Register:deleteMap()
  
end;

function allowDirectPlanting_Register:keyEvent(unicode, sym, modifier, isDown)

end;

function allowDirectPlanting_Register:mouseEvent(posX, posY, isDown, isUp, button)

end;

function allowDirectPlanting_Register:update(dt)
	
end;

function allowDirectPlanting_Register:draw()
  
end;

-- event listener
addModEventListener(allowDirectPlanting_Register);